/*
   06/21/91:  Fixed dumb bug in buffer handling for msgs longer than 8K.
              Old BASIC habits die hard...
   07/12/91:  You can now redirect stdout and get a "clean" (but not
              completely raw--hell, you've got the packet) dump of a
              packet.
              Sped up unredirected OS/2 output w/ Vio call.
   12/26/91:  Added resyncing for grunged packets instead of just dying
              More work on portability
   06/26/92:  Changed FSC-0039 cw recognition per Ralf Pradella's advice
   07/01/92:  Added page pausing for OS/2 version
*/

#ifdef OS2
 #undef  OS2
 #define OS2 1
 #define INCL_DOS
 #define INCL_VIO
 #include <os2.h>
#endif
 #include <stdlib.h>
 #include <stdio.h>
 #include <io.h>
 #include <fcntl.h>
 #include <stdarg.h>
 #include <string.h>
 #include <ctype.h>
 #include <conio.h>
 #include <sys/types.h>
 #include <sys/stat.h>

 /*
  * SHORTs need to be 16 bit integers.  If they aren't Intel format,
  * you've got some conversion to do...  Change the following definition
  * if ints aren't 16 bit or SHORTs are predefined to be something
  * besides 16 bit ints.
  */

#ifndef SHORT
  #define SHORT int
#endif
#ifndef USHORT
  #define USHORT unsigned int
#endif

/*
     This code released to public domain 06/16/91 by M. Kimes, who wrote it.
     Compact or large model, byte alignment, unsigned chars.  No toupper()
     macro.  The executables in the archive were compiled with MSC 6.0a
     for MS-DOS and OS/2.  This code isn't extremely portable -- but I've
     written worse... The FSC-0039 and FSC-0048 stuff is from the latest
     info I have, which might well be out of date by now.
     FSC-0045 is the way to go, anyway.  The code originally began
     as just a way to list the addresses in a packet header.  It got out
     of hand.  I figured the least I could do is share it with other
     developers who might have similar needs, thereby saving them the time
     of Yet Another Project.

     Yes, it could have been written to be bound for OS/2-DOS, but then
     it'd have been hard as hell for pure DOS guys to tweak and recompile.


     Fingers down the throat of Echopol (or whatever name it masquerades
     under these days)...an unpaid apolitical announcement.  And leave
     my damn soul alone.  I'm saving it.

     A word to *ECs who might be tempted to use this program to prove
     software brand x is non-compliant:  remember that the program that
     created a packet isn't necessarily the program that made a "bad"
     message, and that this program is not guaranteed to do more than
     take up space on a disk until you delete it (it might be wrong).
     Throwing someone out of a network because of what this program
     tells you is not a good idea at all.  In fact, it's stupid.

     All opinions expressed are my own.  It'd be dumb if I expressed
     yours, wouldn't it?
*/

/* portability junk just to make it all hard to read */

#ifndef OS2
    typedef struct {
        char                 reserved[21];      /* reserved by MS-DOS */
        char                 attrFile;          /* attributes */
        unsigned             ftimeLastWrite;    /* time */
        unsigned             fdateLastWrite;    /* date */
        unsigned long        cbFile;            /* file size */
        char                 achName[13];       /* file name */
    } DOSFileData;
#else
    #include <malloc.h>
    #define DOSFileData FILEFINDBUF
#endif

/* include proper header files and create macros */
#if defined OS2
    #define FIND_FIRST(spec,attr,buf) DosFindFirst(spec,&search_handle,attr,buf,sizeof(FILEFINDBUF),&num_matches,0L)
    #define FIND_NEXT(buf) DosFindNext(search_handle,buf,sizeof(FILEFINDBUF),&num_matches)
    #define FIND_CLOSE() DosFindClose(search_handle)
    char * PASCAL searchpath (char *filename);
    #define make_color(c) (curattr=(c))
#elif defined (_MSC_VER) || defined(_QC) || defined(__WATCOMC)
    #include "direct.h"
    #include "dos.h"
    #ifndef PASCAL
     #define PASCAL _pascal
    #endif
    #define FIND_FIRST(spec, attr, buf) _dos_findfirst(spec, attr, (struct find_t *)buf)
    #define FIND_NEXT(buf) _dos_findnext((struct find_t *)buf)
    #define FIND_CLOSE()
    char * PASCAL searchpath(char *filename);
#elif defined (__TURBOC__)
    #include "dir.h"
    #ifndef PASCAL
     #define PASCAL pascal
    #endif
    #define FIND_FIRST(spec, attr, buf) findfirst(spec, (struct ffblk *)buf,attr)
    #define FIND_NEXT(buf) findnext((struct ffblk *)buf)
        #define FIND_CLOSE()
        #ifdef putchar
            #undef putchar
            SHORT PASCAL putchar (SHORT ch);
        #endif
#elif defined (__ZTC__)
    #include "dos.h"
    #ifndef PASCAL
     #define PASCAL pascal
    #endif
    #define FIND_FIRST(spec, attr, buf) dos_findfirst(spec, attr, (struct DOS_FIND *)buf)
    #define FIND_NEXT(buf) dos_findnext((struct DOS_FIND *)buf)
    #define FIND_CLOSE(buf)
    char * PASCAL searchpath(char *filename);
#endif

#ifndef OS2
 #define helpgetch() getch()
#endif

typedef struct  {     /* FSC-0045 */
    USHORT
        onode,
        dnode,
        opoint,
        dpoint;
    char
        zeros[8];
    USHORT
        subver,       /* 2 */
        version,      /* 2 */
        onet,
        dnet;
    char
        product,
        rev_lev,
        password[8];
    USHORT
        ozone,
        dzone;
    char
        odomain[8],
        ddomain[8];
    long
        specific;
} NEWPKTHDR;

typedef struct {               /* close to stoneage */
    USHORT
        orig_node,             /* originating node */
        dest_node,             /* destination node */
        year,                  /* 1989 - nnnnn */
        month,
        day,
        hour,
        minute,
        second,
        rate,                  /* unused */
        ver,                   /* 2 */
        orig_net,              /* originating net */
        dest_net;              /* destination net */
     char
        product,
        rev_lev,               /* revision level */
        password[8];
     USHORT
        qm_orig_zone,
        qm_dest_zone;
     char
                domain[8];
     USHORT
        orig_zone,             /* originating zone */
        dest_zone,             /* destination zone */
        orig_point,            /* originating point */
        dest_point;            /* destination point */
     long
        pr_data;
} OLDPKTHDR;

typedef struct {               /* FSC-0039 */
    USHORT
        orig_node,             /* originating node */
        dest_node,             /* destination node */
        year,                  /* 1989 - nnnnn */
        month,
        day,
        hour,
        minute,
        second,
        rate,                  /* unused */
        ver,                   /* 2 */
        orig_net,              /* originating net */
        dest_net;              /* destination net */
     char
        product,
        rev_lev,               /* revision level */
        password[8];
     USHORT
        qm_orig_zone,
        qm_dest_zone;
     char
        filler[2];
     USHORT
        capword2;
     char
        product2,
        rev_lev2;
     USHORT
        capword,
        orig_zone,             /* originating zone */
        dest_zone,             /* destination zone */
        orig_point,            /* originating point */
        dest_point;            /* destination point */
     long
        pr_data;
} MEDPKTHDR;

typedef struct {               /* FSC-0048 */
    USHORT
        orig_node,             /* originating node */
        dest_node,             /* destination node */
        year,                  /* 1989 - nnnnn */
        month,
        day,
        hour,
        minute,
        second,
        rate,                  /* unused */
        ver,                   /* 2 */
        orig_net,              /* originating net */
        dest_net;              /* destination net */
     char
        product,
        rev_lev,               /* revision level */
        password[8];
     USHORT
        qm_orig_zone,
        qm_dest_zone,
        aux_net;
     USHORT
        capword2;
     char
        product2,
        rev_lev2;
     USHORT
        capword,
        orig_zone,             /* originating zone */
        dest_zone,             /* destination zone */
        orig_point,            /* originating point */
        dest_point;            /* destination point */
     long
        pr_data;
} MEDPKTHDR2;

/*--------------------------------------------------------------------------*/
/* FIDO Message attributes (attr) (informational)                           */
/*--------------------------------------------------------------------------*/
#define MSGPRIVATE 0x0001  /* private message,          0000 0000 0000 0001 */
#define MSGCRASH   0x0002  /* accept for forwarding     0000 0000 0000 0010 */
#define MSGREAD    0x0004  /* read by addressee         0000 0000 0000 0100 */
#define MSGSENT    0x0008  /* sent OK (remote)          0000 0000 0000 1000 */
#define MSGFILE    0x0010  /* file attached to msg      0000 0000 0001 0000 */
#define MSGFWD     0x0020  /* being forwarded           0000 0000 0010 0000 */
#define MSGORPHAN  0x0040  /* unknown dest node         0000 0000 0100 0000 */
#define MSGKILL    0x0080  /* kill after mailing        0000 0000 1000 0000 */
#define MSGLOCAL   0x0100  /* FidoNet vs. local         0000 0001 0000 0000 */
#define MSGXX1     0x0200  /*                           0000 0010 0000 0000 */
#define MSGXX2     0x0400  /* STRIPPED by FidoNet<tm>   0000 0100 0000 0000 */
#define MSGFRQ     0x0800  /* file request              0000 1000 0000 0000 */
#define MSGRRQ     0x1000  /* receipt requested         0001 0000 0000 0000 */
#define MSGCPT     0x2000  /* is a return receipt       0010 0000 0000 0000 */
#define MSGARQ     0x4000  /* audit trail requested     0100 0000 0000 0000 */
#define MSGURQ     0x8000  /* update request            1000 0000 0000 0000 */

typedef struct {
    USHORT onode,dnode,onet,dnet,attr;
    SHORT          cost;
} MSGHDR;

#define C_RED         (4 | 8)
#define C_BLINKINGRED (4 | 8 | 128)
#define C_BLUE        (1 | 8)
#define C_GREEN       (2 | 8)
#define C_REVERSE     (7 << 4)
#define C_YELLOW      (6 | 8)
#define C_AQUA        (3 | 8)
#define C_GREY        7

/* global variables */

char   subj[72] = "";
char   from[36] = "";
char   to[36] = "";
char   mdate[20] = "";
#ifdef OS2
 char _far *help = NULL;
#endif
MSGHDR mh;
SHORT  screenheight,screenwidth;
SHORT  curx = 0,cury = 0;
char   curattr;
SHORT  nonstop = 0;
SHORT  stdout_redirected;  /* gets set if stdout is redirected */
SHORT  pauseokay = 0;

/* functions in this module */

SHORT  PASCAL        printstring            (char *s);
SHORT  PASCAL        printtext              (char *s);
void   PASCAL        pause                  (void);
void                 deinit                 (void);
void   PASCAL        display_product        (USHORT product,
                                             USHORT rev_lev);
char * PASCAL        stripcr                (char *a);
SHORT  PASCAL        is_stdout_redirected   (void);
SHORT                (*printfunc)(const char *fmt,...);
SHORT                (*putfunc)(SHORT c);
#ifdef OS2
 SHORT               fake_printf            (const char *szFormat,...);
 SHORT               fake_putchar           (SHORT c);
 SHORT  PASCAL       popup_help             (void);
 SHORT  PASCAL       mygetch                (void);
 SHORT  PASCAL       helpgetch              (void);
#endif
USHORT  PASCAL       byteswap               (USHORT b);
void    PASCAL       get_screen_size        (void);
#ifndef OS2
 void   PASCAL       make_color             (int color);
#else
 void   PASCAL       hide_cursor            (void);
 void   PASCAL       display_header         (void);
#endif
void    PASCAL       clear_screen           (void);


int main (int argc,char *argv[]) {

  /* awful, hideous, brutally effective main function does most of the work */

#ifdef OS2
    SHORT        search_handle;
    USHORT       num_matches;
#endif
  static char  buffer[8194];
  static char  attrstr[16][11] = {
                "MSGPRIVATE","MSGCRASH","MSGREAD","MSGSENT","MSGFILE","MSGFWD",
                "MSGORPHAN","MSGKILL","MSGLOCAL","MSGXX1","MSGXX2","MSGFRQ",
                "MSGRRQ","MSGCPT","MSGARQ","MSGURQ"};
  FILE         *fp;
  OLDPKTHDR    po;
  NEWPKTHDR    *pn;
  MEDPKTHDR    *pm;
  MEDPKTHDR2   *pl;
  DOSFileData  f;
  SHORT        lastargc = 1,numsent,stopsending,retcode;
  size_t       br;
  char         *spec = "*.PKT",*p;
  USHORT       ozone,dzone,anint,msgno = 0,pktno = 0,x;
  long         pos,totalmsgs = 0;


  /* setup default output functions */

  printfunc = printf;
  putfunc = putchar;

    atexit(deinit);

    {
        int handle;

        handle = fileno(stdout);
        setmode(handle,O_BINARY);
        setvbuf(stdout,NULL,_IONBF,0);
        handle = fileno(stderr);
        setmode(handle,O_BINARY);
        setvbuf(stderr,NULL,_IONBF,0);
    }

    stdout_redirected = is_stdout_redirected();

#ifdef OS2
    if(!stdout_redirected) {

        /* redirect screen i/o to faster functions */

        printfunc = fake_printf;
        putfunc = fake_putchar;
        get_screen_size();
    }
#endif

    if(!stdout_redirected) {
        make_color(C_BLUE);
        clear_screen();
        (*printfunc)("Packet explorer for developers by M. Kimes  "__DATE__"  "__TIME__"\r\n\r\n");
#ifndef OS2
        (*printfunc)("    Controls:\r\n"
                     "  [P]ause msg (or [Spacebar])\r\n  [S]kip msg\r\n"
                     "  [A]bort pkt (next pkt)\r\n E[X]it\r\n\r\n");
#else
        (*printfunc)("    At end of page:\r\n"
                     "  [N]onstop\r\n  [S]kip msg\r\n  [A]bort pkt (next pkt)\r\n"
                     " E[X]it\r\n  [?] or [F1] = Help\r\n\r\n");
#endif
        (*printfunc)("    Color codes:\r\n");
        make_color(C_BLINKINGRED);
        (*printfunc)(" Serious");
        make_color(C_RED);
        (*printfunc)(" Error\r\n");
        make_color(C_YELLOW);
        (*printfunc)(" Packet header information\r\n");
        make_color(C_AQUA);
        (*printfunc)(" Msg header information\r\n");
        make_color(C_GREY);
        (*printfunc)(" Msg text\r\n ");
        make_color(C_REVERSE);
        (*printfunc)("Hex control code representation\r\n");
        make_color(C_GREEN);
        (*printfunc)(" Summary information\r\n");
    }

    if(argc > 1) {    /* command line non-stop switch */
      if(!stricmp(argv[1],"-N") || !stricmp(argv[1],"/N")) {
        nonstop++;
        lastargc++;
      }
    }

    if(argc > lastargc) {
        spec = argv[lastargc];
        if(!stdout_redirected)
          (*printfunc)("\r\n Using command line filespec %s\r\n",argv[1]);
        else fprintf(stderr,"\n Using command line filespec %s\n",argv[1]);
        lastargc++;
    }
    else {
        if(!stdout_redirected)
          (*printfunc)("\r\n Using filespecs *.PKT and *.?U?");
        else fprintf(stderr,"\n Using filespecs *.PKT and *.?U?");
#ifdef OS2
        if(!stdout_redirected) (*printfunc)(" and P.*.*.*.*.*");
        else fprintf(stderr," and P.*.*.*.*.*");
#endif
        if(!stdout_redirected) {
          make_color(C_BLUE);
          (*printfunc)("\r\n\r\n(You can also pass a filespec on the command line.)\r\n");
        }
        else fprintf(stderr,"\r\n(You can also pass a filespec on the command line.)\n");
    }
    if(!stdout_redirected) {
#ifdef OS2
        help = _fmalloc((screenwidth * screenheight) * 2);
        if(help) {

          int len;

          len = (screenwidth * screenheight) * 2;
          VioReadCellStr(help,&len,0,0,0);
        }
#endif
        make_color(C_BLUE);
        (*printfunc)("\r\n    [Any Key to begin]");
#ifdef OS2
        hide_cursor();
#endif
        mygetch();
        clear_screen();
    }

    pn = (NEWPKTHDR *)&po;
    pl = (MEDPKTHDR2 *)&po;
    pm = (MEDPKTHDR *)&po;

/* who's afraid of a little goto? */

OverAgain:

#ifdef OS2
    search_handle = -1;
    num_matches = 1;
#endif

    do {
        p = strchr(spec,'\\');
        if(p) *p = '/';
    } while(p);

    p = strrchr(spec,'/');
    if(!p) p = strrchr(spec,':');
    if(p) {
        p++;
    }

    if(!FIND_FIRST(spec,0,&f)) {
        do {
#ifdef OS2
            hide_cursor();
#endif
            if(!nonstop && (pktno || msgno) && !stdout_redirected) {
#ifdef OS2
              DosBeep(1000,1);
#else
              printf("\07");
#endif
              helpgetch();
              clear_screen();
            }
            pktno++;
            msgno = 0;
            if(p) {
                *p = 0;
                sprintf(buffer,"%s%s",spec,f.achName);
            }
            else strcpy(buffer,f.achName);
            fp = fopen(buffer,"rb");
            make_color(C_YELLOW);
            if(!fp) {
                (*printfunc)("\r\n");
                make_color(C_BLINKINGRED);
                (*printfunc)("Couldn't open packet \"%s\"\r\n",f.achName);
                make_color(C_GREY);
            }
            else {
                br = fread(&po,1,sizeof(OLDPKTHDR),fp);
                if(br < sizeof(OLDPKTHDR)) {
                    (*printfunc)("\r\n");
                    make_color(C_BLINKINGRED);
                    (*printfunc)("Packet %s short:  %u byte%s",f.achName,br,&"s"[1 == br]);
                }
                else if(po.ver != 2) {
                    (*printfunc)("\r\n");
                    make_color(C_BLINKINGRED);
                    (*printfunc)("\"%s\" not version 2.x; may not be a packet",f.achName);
                    pktno--;
                }
                else {
                    if(po.rate == 2) {  /* preferred method */
                        (*printfunc)("\r\nFSC-0045 (AKA version 2.2) packet:  \"%s\"",f.achName);
                        (*printfunc)("\r\nFrom %u:%u/%u.%u@%0.8s to %u:%u/%u.%u@%0.8s",
                               pn->ozone,pn->onet,pn->onode,pn->opoint,pn->odomain,
                               pn->dzone,pn->dnet,pn->dnode,pn->dpoint,pn->ddomain);
                        (*printfunc)("\r\nProduced by product #%hu.%hu   Password: \"%0.8s\"",
                               pn->product,pn->rev_lev,pn->password);
                        display_product(pn->product,pn->rev_lev);
                    }
                    else if((pl->capword && pl->capword == pl->capword2) ||
                            (pl->orig_net == -1 && pl->capword &&
                             pl->capword == byteswap(pl->capword2))) {
                        (*printfunc)("\r\nFSC-0048 (AKA version 2.N) packet:  \"%s\"",f.achName);
                        ozone = pl->orig_zone;
                        dzone = pl->dest_zone;
                        if(!ozone) ozone = pl->qm_orig_zone;
                        if(!dzone) dzone = pl->qm_dest_zone;
                        if(pl->orig_net == 65535U) {
                            (*printfunc)("\r\nFrom %u:%u/%u.0@???????? to %u:%u/%u.%u@????????",
                                   ozone,pl->orig_net,pl->orig_node,
                                   dzone,pl->dest_net,pl->dest_node,pl->dest_point);
                        }
                        else {
                            (*printfunc)("\r\nFrom %u:%u/%u.%u@???????? to %u:%u/%u.%u@????????",
                                   ozone,pl->aux_net,pl->orig_node,pl->orig_point,
                                   dzone,pl->dest_net,pl->dest_node,pl->dest_point);
                        }
                        ozone = pl->product + (pl->product2 << 8);
                        dzone = pl->rev_lev + (pl->rev_lev2 << 8);
                        (*printfunc)("\r\nProduced by product #%u.%u  Password: \"%0.8s\"  Capword: %u",
                               ozone,dzone,pm->password,pm->capword);
                        display_product(ozone,dzone);
                    }
                    else if(pm->capword && pm->capword == byteswap(pm->capword2)) {
                        (*printfunc)("\r\nFSC-0039 (AKA version 2.+) [or FSC-0048, AKA version 2.N?) packet:  \"%s\"",f.achName);
                        ozone = pm->orig_zone;
                        dzone = pm->dest_zone;
                        if(!ozone) ozone = pm->qm_orig_zone;
                        if(!dzone) dzone = pm->qm_dest_zone;
                        (*printfunc)("\r\nFrom %u:%u/%u.%u@???????? to %u:%u/%u.%u@????????",
                               ozone,pm->orig_net,pm->orig_node,pm->orig_point,
                               dzone,pm->dest_net,pm->dest_node,pm->dest_point);
                        ozone = pm->product + (pm->product2 << 8);
                        dzone = pm->rev_lev + (pm->rev_lev2 << 8);
                        (*printfunc)("\r\nProduced by product #%u.%u  Password: \"%0.8s\"  Capword: %u",
                               ozone,dzone,pm->password,pm->capword);
                        display_product(ozone,dzone);
                    }
                    else {
                        (*printfunc)("\r\nStoneage (AKA version 2) packet:  \"%s\"",f.achName);
                        ozone = po.qm_orig_zone;
                        dzone = po.qm_dest_zone;
                        if(!ozone) ozone = po.orig_zone;
                        if(!dzone) dzone = po.dest_zone;
                        (*printfunc)("\r\nFrom %u:%u/%u.%u@???????? to %u:%u/%u.%u@%0.8s",
                               ozone,po.orig_net,po.orig_node,po.orig_point,
                               dzone,po.dest_net,po.dest_node,po.dest_point,
                               po.domain);
                        (*printfunc)("\r\nProduced by #%hu.%hu  Password: \"%0.8s\"",
                               po.product,po.rev_lev,po.password);
                        display_product(po.product,po.rev_lev);
                    }
                    for(;;) {

GrungeReSync:

                        if(!fread(&anint,sizeof(SHORT),1,fp)) {
                            (*printfunc)("\r\n");
                            make_color(C_BLINKINGRED);
                            (*printfunc)("Unexpected end of packet");                           break;
                        }
                        if(!anint || anint != 2) {
                            if(!anint) {
                                (*printfunc)("\r\n");
                                make_color(C_GREEN);
                                (*printfunc)("End of packet: %u msg%s",
                                       msgno,&"s"[1 == msgno]);
                            }
                            else {
                                (*printfunc)("\r\n");
                                make_color(C_BLINKINGRED);
                                (*printfunc)("Grunged packet: attempting resync, expect some garbage");
                                if(kbhit() && toupper(mygetch()) == 'A') {
                                    (*printfunc)("\r\nKeyboard abort\r\n");
                                    goto NextPacket;
                                }
                                fseek(fp,-1L,SEEK_CUR);
                                goto GrungeReSync;
                            }
                            goto NextPacket;
                        }
                        if(!nonstop && msgno && !stdout_redirected) {
#ifdef OS2
                          DosBeep(1000,1);
#else
                          printf("\07");
#endif
                          helpgetch();
                          clear_screen();
                        }
                        br = fread(&mh,1,sizeof(mh),fp);
                        if(br < sizeof(mh)) {
                            (*printfunc)("\r\n");
                            make_color(C_BLINKINGRED);
                            (*printfunc)("Incomplete msg header");
                            break;
                        }
                        (*printfunc)("\r\n\r\n");
                        make_color(C_AQUA);
                        (*printfunc)("Msg #%u from %u/%u to %u/%u",++msgno,
                               mh.onet,mh.onode,mh.dnet,mh.dnode);

                        (*printfunc)("  *  Attrib: %u  Cost: %d",mh.attr,mh.cost);
                        totalmsgs++;
                        if(mh.attr) {
                            (*printfunc)("\r\n");
                            for(x = 0;x < 16;x++) {
                                if(mh.attr & (1 << x)) (*printfunc)("%s ",attrstr[x]);
                            }
                        }
                        pos = ftell(fp);
                        br = fread(buffer,1,20,fp);
                        if(br < 20) {
                            (*printfunc)("\r\n");
                            make_color(C_BLINKINGRED);
                            (*printfunc)("Incomplete msg header");
                            break;
                        }
                        for(x = 0;x < 19;x++) {
                            if(buffer[x] == 0) break;
                        }
                        if(x == 19 && buffer[19] == 0) (*printfunc)("\r\nDate: ");
                        else {
                            (*printfunc)("\r\n");
                            make_color(C_BLINKINGRED);
                            (*printfunc)("Grunged");
                            make_color(C_AQUA);
                            (*printfunc)(" date: ");
                        }
                        buffer[19] = 0;
                        strcpy(mdate,buffer);
                        if(printstring(buffer) == -1) goto NextPacket;
                        fseek(fp,pos + (long)strlen(buffer) + 1L,SEEK_SET);
                        pos = ftell(fp);
                        if(!fread(buffer,1,36,fp)) {
                            (*printfunc)("\r\n");
                            make_color(C_BLINKINGRED);
                            (*printfunc)("Incomplete msg header");
                            break;
                        }
                        for(x = 0;x < 36;x++) {
                            if(buffer[x] == 0) break;
                        }
                        if(x == 36) {
                            (*printfunc)("\r\n");
                            make_color(C_BLINKINGRED);
                            (*printfunc)("Grunged");
                            make_color(C_AQUA);
                            (*printfunc)(" to: ");
                        }
                        else (*printfunc)("\r\nTo:   ");
                        buffer[35] = 0;
                        strcpy(to,buffer);
                        if(printstring(buffer) == -1) goto NextPacket;
                        fseek(fp,pos + (long)strlen(buffer) + 1L,SEEK_SET);
                        pos = ftell(fp);
                        if(!fread(buffer,1,36,fp)) {
                            (*printfunc)("\r\n");
                            make_color(C_BLINKINGRED);
                            (*printfunc)("Incomplete msg header");
                            break;
                        }
                        for(x = 0;x < 36;x++) {
                            if(buffer[x] == 0) break;
                        }
                        if(x == 36) {
                            (*printfunc)("\r\n");
                            make_color(C_BLINKINGRED);
                            (*printfunc)("Grunged");
                            make_color(C_AQUA);
                            (*printfunc)(" from: ");
                        }
                        else (*printfunc)("\r\nFrom: ");
                        buffer[35] = 0;
                        strcpy(from,buffer);
                        if(printstring(buffer) == -1) goto NextPacket;
                        fseek(fp,pos + (long)strlen(buffer) + 1L,SEEK_SET);
                        pos = ftell(fp);
                        if(!fread(buffer,1,72,fp)) {
                            (*printfunc)("\r\n");
                            make_color(C_BLINKINGRED);
                            (*printfunc)("Incomplete msg header");
                            break;
                        }
                        for(x = 0;x < 72;x++) {
                            if(buffer[x] == 0) break;
                        }
                        if(x == 72) {
                            (*printfunc)("\r\n");
                            make_color(C_BLINKINGRED);
                            (*printfunc)("Grunged");
                            make_color(C_AQUA);
                            (*printfunc)(" subj: ");
                        }
                        else (*printfunc)("\r\nSubj: ");
                        buffer[71] = 0;
                        strcpy(subj,buffer);
                        if(printstring(buffer) == -1) goto NextPacket;
                        fseek(fp,pos + (long)strlen(buffer) + 1L,SEEK_SET);
                        pos = ftell(fp);
                        memset(buffer,0,8193);
                        if(!fread(buffer,1,8192,fp)) {
                            (*printfunc)("\r\n");
                            make_color(C_BLINKINGRED);
                            (*printfunc)("No msg text");
                            break;
                        }
                        stopsending = 0;
                        do {
                            for(x = 0;x < 8192;x++) {
                                if(buffer[x] == 0) break;
                            }
                            if(!x) break;
                            buffer[8192] = 0;
                            numsent = min(8192,x);
                            make_color(C_GREY);
                            (*printfunc)("\r\n");
                            if(!stopsending) {
                                retcode = printtext(buffer);
                                if(retcode == -1) {
                                  goto NextPacket;
                                }
                                if(retcode < numsent) {
                                  stopsending++;
                                }
                            }
                            if(x == 8192) {
                                pos = ftell(fp);
                                memset(buffer,0,8193);
                                if(!fread(buffer,1,8192,fp)) {
                                    (*printfunc)("\r\n");
                                    make_color(C_BLINKINGRED);
                                    (*printfunc)("Premature end of message");
                                    goto NextPacket;
                                }
                            }
                        } while(x == 8192);
                        fseek(fp,pos + (long)strlen(buffer) + 1L,SEEK_SET);
                        pos = ftell(fp);
                    }
/* NextMsg */
                    make_color(C_GREY);
                    *from = *to = *subj = *mdate = 0;
                    nonstop++;
                    (*printfunc)("\r\n");
                    nonstop--;
                }

NextPacket:

                fclose(fp);
            }

#ifdef OS2
            num_matches = 1;
#endif

        } while(!FIND_NEXT(&f));
        FIND_CLOSE();
        if(!nonstop && (pktno && msgno) && !stdout_redirected) {
#ifdef OS2
          DosBeep(1000,1);
#else
          printf("\07");
#endif
          helpgetch();
        }
    }

    if(!stricmp(spec,"*.PKT")) {
        spec = "*.?U?";
        goto OverAgain;
    }
#ifdef OS2
    else if(!stricmp(spec,"*.?U?")) {
        spec = "P.*.*.*.*.*";
        goto OverAgain;
    }
#endif
    else {
        if(argc > lastargc) {
            spec = argv[lastargc++];
            make_color(C_GREEN);
            (*printfunc)("\r\n Using command line filespec %s",spec);
            goto OverAgain;
        }
    }
    if(!pktno) {
        (*printfunc)("\r\n");
        make_color(C_GREEN);
        (*printfunc)("No packets were found.");
    }
    else {
        (*printfunc)("\r\n");
        make_color(C_GREEN);
        (*printfunc)("Found %u packet%s w/ %lu msg%s",
               pktno,&"s"[1 == pktno],totalmsgs,&"s"[1L == totalmsgs]);
    }

#ifdef OS2
    if(help) _ffree(help);
#endif

    return 0;
}


SHORT PASCAL printstring (char *s) {

    /*
     * output the text in s; do it fast and check for user interrupt/pause
     * if not redirected.  max string len == 8192 bytes.
     */

    USHORT x;
    SHORT  kp;
    SHORT  ret = 0;


    pauseokay = 1;
    (*putfunc)('\"');
    for(x = 0; x < 8192;x++) {
        if(!s[x]) break;
        if(isprint(s[x])) ret = (*putfunc)(s[x]);
        else {
            if(!stdout_redirected) {
              make_color(C_REVERSE);
              ret = (*printfunc)("%02hx",s[x]);
              make_color(C_AQUA);
            }
            else ret = (*putfunc)(s[x]);
        }
        if(ret == -1) break;
        else if(ret == -2) {
          pauseokay = 0;
          return -1;
        }
    }
    ret = (*putfunc)('\"');
    if(ret == -2) {
      pauseokay = 0;
      return -1;
    }
    if(nonstop && !stdout_redirected) {
        if(kbhit()) {               /* kbhit -- return true if keypress waiting */
            kp = toupper(helpgetch());  /* getch -- wait for character, return without echo */
            switch(kp) {
                case ' ':
                case 'P':   pause();
                            break;
                case 'X':   exit(3);
                case 'A':   pauseokay = 0;
                            return -1;
                case 'N':   nonstop--;
                            break;
            }
        }
    }
    pauseokay = 0;
    return x;
}



SHORT PASCAL printtext (char *s) {

    /* output the text in s; do it fast and check for user interrupt/pause
     * if not redirected.  max string len == 8192 bytes.
     */

    USHORT x;
    SHORT  kp;
    SHORT  ret = 0;


    pauseokay = 1;
    for(x = 0; x < 8192;x++) {
        if(!s[x]) break;
        if(isprint(s[x])) ret = (*putfunc)(s[x]);
        else if(s[x] == '\r' || !(x % 79)) {
            if(s[x] == '\r') {
                if(!stdout_redirected) {
                  make_color(C_REVERSE);
                  (*printfunc)("%02hx",s[x]);
                  make_color(C_GREY);
                }
                ret = (*printfunc)("\r\n");
            }
            if(nonstop && !stdout_redirected) {
                if(kbhit()) {
                    kp = toupper(helpgetch());
                    switch(kp) {
                        case ' ':
                        case 'P':   pause();
                                    break;
                        case 'S':   goto BreakOut;
                        case 'X':   exit(3);
                        case 'A':   pauseokay = 0;
                                    return -1;
                        case 'N':   nonstop--;
                                    break;
                    }
                }
            }
        }
        else {
            if(!stdout_redirected) {
              make_color(C_REVERSE);
              ret = (*printfunc)("%02hx",s[x]);
              make_color(C_GREY);
            }
            else {
                if(s[x] != '\n') ret = (*putfunc)(s[x]);
            }
        }

        if(ret == -1) break;
        else if(ret == -2) {
          pauseokay = 0;
          return -1;
        }
    }

BreakOut:

    pauseokay = 0;
    return x;
}


void PASCAL pause (void) {

    /* wait for P to be pressed */

    SHORT kp;


    if(stdout_redirected) return;
    do {
      while(kbhit()) mygetch(); /* clear keyboard buffer */
      kp = toupper(helpgetch());  /* wait for key */
    } while(kp == 'P');       /* key must be 'p' || 'P' */
}



void deinit (void) {

    if(!stdout_redirected) printf("\x1b[0m");
    fcloseall();
#ifdef OS2
    if(!stdout_redirected) {  /* restore cursor, resync screen */

      VIOCURSORINFO  vc;

      VioSetCurPos(cury,curx,0);
      VioGetCurType (&vc, 0);
      vc.attr = 0;
      VioSetCurType (&vc, 0);
    }
#endif
    printf("\n");
}



void PASCAL display_product (USHORT product,USHORT rev_lev) {

    /* give some info about the product that made a packet */

    char    s[133],*p;
    USHORT  prod;
    FILE    *fp;


    if(!product) {
        (*printfunc)("\r\nFido <tm> or an unregistered product rev %u",rev_lev);
        return;
    }

    p = searchpath("FTSCPROD.LST");
    if(p) {
        fp = fopen(p,"rt");
        if(!fp) {
            (*printfunc)("\r\n");
            if(!stdout_redirected)make_color(C_RED);
            (*printfunc)("Couldn't open %s",p);
            make_color(C_YELLOW);
            return;
        }
        while(!feof(fp)) {
            if(!fgets(s,132,fp)) break;
            if(*s != ';') {
                p = s;
                prod = (USHORT)strtol(s,&p,16);
                if(prod == product) {
                    if(*p) {
                        p++;
                        stripcr(p);
                        (*printfunc)("\r\n%s rev %u",p,rev_lev);
                    }
                    else (*printfunc)("\r\n??? rev %u",rev_lev);
                    fclose(fp);
                    return;
                }
            }
        }
        fclose(fp);
    }
    (*printfunc)("\r\nUnknown product rev %u",rev_lev);
}


#if !defined __TURBOC__

char * PASCAL searchpath (char *filename) {

    /* look up a file along a list of directories.  Directories separated
     * from each other with the ';' character
     */

    static char fbuf[153];
    struct stat st;
    char        *envbuf = NULL,*p,temp;


    p = getenv("PATH");
    if(!p) return filename;
    envbuf = strdup(p);
    if(!envbuf) return filename;

    p = strtok(envbuf,";");
    do {
        strncpy(fbuf,p,128);
        fbuf[128] = 0;
        temp = fbuf[strlen(fbuf) - 1];
        if(temp != '/' && temp != '\\') strcat(fbuf,"\\");
        strcat(fbuf,filename);
        if(!stat(fbuf,&st)) {
            if(envbuf) free(envbuf);
            return fbuf;
        }
        p = strtok(0,";");
    } while(p);
    if(envbuf) free(envbuf);
    return NULL;
}

#endif



char * PASCAL stripcr (char *a) {

    /* remove \r and \n's from end of a string */

    register SHORT x;


    x = strlen(a);
    while (x && (a[x - 1] == '\n' || a[x - 1] == '\r')) a[--x] = 0;
    return a;

}


SHORT PASCAL is_stdout_redirected (void) {

    /* check to see if stdout is redirected.  return non-zero if so */

#ifdef OS2
    USHORT info,devhead;
#else
    union REGS   rg;
#endif

#ifndef OS2

    rg.h.ah = 0x44;
    rg.h.al = 0x00;
    rg.x.bx = fileno(stdout);
    int86(0x21,&rg,&rg);
        if(!rg.x.cflag) {
        if(rg.x.dx & 128) {
           if(rg.x.dx & 2) return 0;
        }
    }
    return 1;

#else

    DosQHandType(fileno(stdout),&info,&devhead);
    if(((info & 255) == 1) && (devhead & 2)) return 0;
    return 1;

#endif
}



#ifdef OS2

SHORT fake_printf (const char *szFormat,...) {

    /* print to screen */

    SHORT       len;
    char        chBuffer[1000];
    va_list     pArguments;
    char        *p;


    va_start(pArguments,szFormat);
    len = vsprintf(chBuffer,szFormat,pArguments);
    va_end(pArguments);
    p = chBuffer;
    while(*p) {
      switch(*p) {
        case '\r':
          curx = 0;
          break;
        case '\n':
          cury++;
          break;
        default:
          VioWrtCharStrAtt(p,1,cury,curx,&curattr,0);
          curx++;
          break;
      }
      if(curx >= screenwidth - 1) {
        curx = 0;
        cury++;
      }
      if(cury >= screenheight - 1) {

        SHORT attr = (curattr << 8) | ' ';

        if(!nonstop && pauseokay) {

          int key;

          DosBeep(1000,1);
          key = toupper(helpgetch());
          if(key == 'N') nonstop++;
          else if(key == 'X') exit(3);
          else if(key == 'S') return -1;
          else if(key == 'A') return -2;
          clear_screen();
          curx = cury = 0;
          display_header();
        }
        else {
          VioScrollUp(0,0,screenheight - 1,screenwidth - 1,1,(char *)&attr,0);
          cury--;
        }
      }
      p++;
    }
    return len;
}


SHORT fake_putchar (SHORT c) {

    /* print through ANSI but not necessarily stdout */

    char cc = (char)c;


    if(c == '\r') curx = 0;
    else if(c == '\n') cury++;
    else {
      VioWrtCharStrAtt(&cc,1,cury,curx,&curattr,0);
      curx++;
    }
    if(curx >= screenwidth - 1) {
      curx = 0;
      cury++;
    }
    if(cury >= screenheight - 1) {

      SHORT attr = (curattr << 8) | ' ';

      if(!nonstop && pauseokay) {

        int key;

        DosBeep(1000,1);
        key = toupper(mygetch());
        if(key == 'N') nonstop++;
        else if(key == 'S') return -1;
        else if(key == 'A') return -2;
        else if(key == 'X') exit(3);
        clear_screen();
        curx = cury = 0;
        display_header();
      }
      else {
        VioScrollUp(0,0,screenheight - 1,screenwidth - 1,1,(char *)&attr,0);
        cury--;
      }
    }
    return 1;
}

void PASCAL display_header (void) {

  char tempattr = curattr;

  if(*from || *to || *subj || *mdate) {
    make_color(C_AQUA);
    (*printfunc)("From: \"%s\" @ %u/%u\r\n",from,mh.onet,mh.onode);
    (*printfunc)("To:   \"%s\" @ %u/%u\r\n",to,mh.dnet,mh.dnode);
    (*printfunc)("Subj: \"%s\"\r\n",subj);
    (*printfunc)("Date: \"%s\"  --  Attr: %u  --  Cost: %d\r\n\r\n",mdate,
                 mh.attr,mh.cost);
    curattr = tempattr;
  }
}

#endif


#ifdef __TURBOC__


SHORT putchar (SHORT ch) {

  return (SHORT)(putc(ch,stdout));
}

#endif


USHORT PASCAL byteswap (USHORT b) {

  /* swap bytes in an USHORT (for FSC-0039 cw) */

  union {
    struct {
      char  b1;
      char  b2;
    }       b;
    USHORT  x;
  }         BS;
  char      temp;

  BS.x = b;
  temp = BS.b.b1;
  BS.b.b1 = BS.b.b2;
  BS.b.b2 = temp;
  return BS.x;
}


#define A_BLINK   128
#define A_BRIGHT  8
#define A_LOMASK  7
#define A_HIMASK  112
#define A_BLACK   0
#define A_BLUE    1
#define A_GREEN   2
#define A_CYAN    3
#define A_RED     4
#define A_MAGENTA 5
#define A_BROWN   6
#define A_GREY    7


#ifdef OS2

void PASCAL get_screen_size (void) {

  VIOMODEINFO     v;

  v.cb = sizeof (VIOMODEINFO);
  VioGetMode(&v, 0);
  screenwidth  = v.col;
  screenheight = v.row;
}

void PASCAL hide_cursor (void) {

  VIOCURSORINFO  vc;

  if(!stdout_redirected) {
    VioGetCurType (&vc, 0);
    vc.attr = -1;
    VioSetCurType (&vc, 0);
  }
}


#else

static char *a2atranstable[] = {"0","4","2","6","1","5","3","7"};


char * ava2ansi (int avacode) {

  /* construct color ansi escape sequence from avatar-like number */

  int         foreground;
  int         background;
  static char ansioutput[21];

  avacode &= 255;    
  strcpy(ansioutput,"\x1b[");
  background = (avacode & A_HIMASK) >> 4;
  foreground = (avacode & A_LOMASK);
  if (avacode & 8) {
      strcat(ansioutput,"0;1;");
  }
  else strcat(ansioutput,"0;");

  if (!background) {
      strcat(ansioutput,"3");
      strcat(ansioutput,a2atranstable[foreground]);
  }
  else {
      strcat(ansioutput,"3");
      strcat(ansioutput,a2atranstable[foreground]);
      strcat(ansioutput,";4");
      strcat(ansioutput,a2atranstable[background]);
  }
  strcat(ansioutput,"m");
  return ansioutput;
}

/*

The color number is the same as attributes used by IBM PCs:

  bit value:   (128)(64)(32)(16)(8) (4) (2) (1)
                ---  --  --  --  -   -   -   -
  bit:           7   6   5   4   3   2   1   0
                 -   -   -   -   -   -   -   -
                 |   |       |   |   |       |
                 |   +---+---+   |   +---+---+
                 |       |       |       |
                 |       |       |   text color
                 |       |       |
                 |       |     bright text
                 |       |
                 |    background color
                 |
               blink

             0      black
             1      blue
             2      green
             3      cyan
             4      red
             5      magenta
             6      brown
             7      gray  (i.e. non-intense white)

*/

void PASCAL make_color (int color) {

  if(!stdout_redirected)
    (*printfunc)(ava2ansi(color));
}

void PASCAL get_screen_size (void) {

  /* the hell with it */

  screenwidth = screenheight = 0;
}

#endif

void PASCAL clear_screen (void) {

#ifdef OS2
  SHORT attr = (curattr << 8) | ' ';

  if(stdout_redirected) return;
  VioScrollUp(0,0,screenheight - 1,screenwidth - 1,-1,(char *)&attr,0);
#else
  if(stdout_redirected) return;
  printf("\x1b[0m\x1b[2J");
#endif
  curx = cury = 0;
}


#ifdef OS2

SHORT PASCAL popup_help (void) {

  char _far *screen = NULL;
  int       ret = 0,len;

  len = (screenheight * screenwidth) * 2;
  screen = _fmalloc(len);
  if(screen) {
    VioReadCellStr(screen,&len,0,0,0);
    VioWrtCellStr(help,len,0,0,0);
    DosBeep(1000,1);
    ret = mygetch();
    VioWrtCellStr(screen,len,0,0,0);
    _ffree(screen);
  }
  return ret;
}

SHORT PASCAL mygetch (void) {

  SHORT ret;

  if(stdout_redirected) return 0;
  ret = getch();
  if(!ret) ret = getch();
  return ret;
}


SHORT PASCAL helpgetch (void) {

  SHORT key;

  do {
    key = toupper(mygetch());
    if(key == '?' || key == 59) {
      key = popup_help();
      if(key == '?' || key == 59) key = 0;
    }
  } while(!key);
  return key;
}

#endif
